#

set CO_height 15 
set CO_width  60 

set rgbcolorLists {
{0.0 0.0 0.0} 
{0.5 0.0 0.0} 
{0.0 0.5 0.0} 
{0.5 0.5 0.0} 
{0.0 0.0 0.5}
{0.5 0.0 0.5} 
{0.0 0.5 0.5}
{0.5 0.4 0.3}
{0.9 0.8 0.7}

{0.5 0.5 0.5}
{1.0 0.0 0.0}
{0.0 1.0 0.0}
{1.0 1.0 0.0}
{0.0 0.0 1.0}
{1.0 0.0 1.0}
{0.0 1.0 1.0}
{0.8 0.7 0.5}
{1.0 1.0 1.0}
}

set colorLists ""
foreach d "$rgbcolorLists" {
    set tt "\#" 
    foreach dd "$d" { 
        set t [expr $dd * 0xff]
        regexp {([0-9]+)} $t t
        set t [format %02x $t]
        set tt $tt$t 
    }
    lappend colorLists $tt
}

toplevel .top
wm title .top "colors"
wm protocol .top WM_DELETE_WINDOW "wm deiconify .top"
set ww [expr  3+ $CO_width * 2] 
set hh [expr [llength rbgcolorLists] * $CO_height * 13]
canvas .top.c -relief sunken -borderwidth 2  -width $ww \
        -height $hh

wm minsize .top  $ww $hh     
wm maxsize .top  $ww $hh     

pack  .top.c -expand yes -fill both

set w .top

set t 0
set right_inc 0
foreach d "$colorLists" {

    set id [.top.c create rectangle [expr $CO_width * $right_inc] [expr 1 + $t * $CO_height] [expr -1 + $CO_width * ( $right_inc + 1)] [expr 1 + ($t + 1) * $CO_height] -fill $d ]

    if {$t > 7} {
        incr right_inc
        set t 0
    } {
        incr t
    }

    .top.c bind $id   <1> "bindProc $id"
 
}

proc bindProc {item} {

  global colorLists SelectedColor

  incr item -1
  DvsMessageDlg $item
  set item [lindex $colorLists $item]
  set rgb "[winfo rgb .top.c $item]"
    set vsrgb ""
    foreach d "$rgb" {
        set t $d.0
        lappend vsrgb [string range [expr $t / 65535.0] 0 2]
    }
    .top.c configure -background $item
    set SelectedColor "$vsrgb"
    DvsMessageDlg "$vsrgb : $item"
 
}

bindProc 1 
